/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.battle.pvp.IPvPVisitor
 *  fire.pb.battle.pvp.IPvPVisitor$Util$ComparatorRank
 *  fire.pb.battle.pvp.PvPRaceProxy
 *  fire.pb.ranklist.proc.RankListManager
 *  xbean.Pod
 *  xbean.PvP5RaceRole
 *  xbean.PvP5ScoreRankList
 *  xbean.PvP5ScoreRecord
 *  xtable.Properties
 *  xtable.Pvp5historyscorelist
 *  xtable.Pvp5scorelist
 */
package fire.pb.battle.pvp5;

import fire.pb.battle.pvp.IPvPVisitor;
import fire.pb.battle.pvp.PvPRaceProxy;
import fire.pb.battle.pvp5.PvP5Control;
import fire.pb.battle.pvp5.PvP5RaceProxy;
import fire.pb.ranklist.proc.RankListManager;
import java.util.Comparator;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import xbean.Pod;
import xbean.PvP5RaceRole;
import xbean.PvP5ScoreRankList;
import xbean.PvP5ScoreRecord;
import xtable.Properties;
import xtable.Pvp5historyscorelist;
import xtable.Pvp5scorelist;

public class PvP5RankVisitor
implements IPvPVisitor {
    public void visit(PvPRaceProxy pvpRaceProxy) {
        PvP5RaceProxy raceProxy = (PvP5RaceProxy)pvpRaceProxy;
        PvP5RankVisitor.updateLastRankList(raceProxy);
        PvP5RankVisitor.updateHistoryRankList(raceProxy);
    }

    public static void updateLastRankList(PvP5RaceProxy raceProxy) {
        int rankType = PvP5RankVisitor.getLastRankType(raceProxy.getGrade());
        if (rankType == -1) {
            if (PvP5Control.getLogger().isInfoEnabled()) {
                PvP5Control.getLogger().info((Object)("PVP5::[PvP5RankVisitor.updateLastRankList] error race grade:" + raceProxy.getGrade()));
            }
            return;
        }
        int recordMax = PvP5RankVisitor.getLastRankRecordMax(rankType);
        List<PvP5RaceRole> tempRoleList = PvP5RankVisitor.getCurrentRankListAndSort(raceProxy, recordMax);
        PvP5ScoreRankList rankList = Pvp5scorelist.get((Integer)raceProxy.getGrade());
        if (rankList == null) {
            rankList = Pod.newPvP5ScoreRankList();
            Pvp5scorelist.add((Integer)raceProxy.getGrade(), (PvP5ScoreRankList)rankList);
        } else {
            rankList.getRecords().clear();
        }
        for (int i = 0; i < tempRoleList.size() && i < recordMax; ++i) {
            PvP5RaceRole raceRole = tempRoleList.get(i);
            PvP5ScoreRecord record = Pod.newPvP5ScoreRecord();
            record.setRoleid(raceRole.getRoleid());
            record.setRolename(raceRole.getName());
            record.setScore(raceRole.getScore());
            int school = Properties.selectSchool((Long)raceRole.getRoleid());
            record.setSchool(school);
            rankList.getRecords().add(record);
        }
    }

    public static void updateHistoryRankList(PvP5RaceProxy raceProxy) {
        int rankType = PvP5RankVisitor.getHistoryRankType(raceProxy.getGrade());
        if (rankType == -1) {
            if (PvP5Control.getLogger().isInfoEnabled()) {
                PvP5Control.getLogger().info((Object)("PVP5::[PvP5RankVisitor.updateHistoryRankList] error race grade:" + raceProxy.getGrade()));
            }
            return;
        }
        int recordShowMax = PvP5RankVisitor.getHistoryRankRecordShowMax(rankType);
        int recordMax = PvP5RankVisitor.getHistoryRankRecordMax(rankType);
        List<PvP5RaceRole> tempRoleList = PvP5RankVisitor.getCurrentRankListAndSort(raceProxy, recordMax);
        PvP5ScoreRankList rankList = Pvp5historyscorelist.get((Integer)raceProxy.getGrade());
        if (rankList == null) {
            rankList = Pod.newPvP5ScoreRankList();
            Pvp5historyscorelist.add((Integer)raceProxy.getGrade(), (PvP5ScoreRankList)rankList);
        }
        for (PvP5ScoreRecord record : rankList.getRecords()) {
            Iterator<PvP5RaceRole> it = tempRoleList.iterator();
            while (it.hasNext()) {
                PvP5RaceRole r = it.next();
                if (r.getRoleid() != record.getRoleid()) continue;
                record.setScore(record.getScore() + r.getScore());
                it.remove();
            }
        }
        List records = rankList.getRecords();
        for (int i = 0; i < tempRoleList.size(); ++i) {
            PvP5RaceRole raceRole = tempRoleList.get(i);
            PvP5ScoreRecord record = Pod.newPvP5ScoreRecord();
            record.setRoleid(raceRole.getRoleid());
            record.setRolename(raceRole.getName());
            record.setScore(raceRole.getScore());
            records.add(record);
        }
        tempRoleList.clear();
        PvP5RankVisitor.sort(rankList.getRecords(), PvP5RankVisitor.getCurrentRankMap(raceProxy));
        PvP5RankVisitor.resize(rankList.getRecords(), recordMax);
        PvP5RankVisitor.updateSchool(rankList.getRecords(), recordShowMax);
    }

    public static Map<Long, Integer> getCurrentRankMap(PvP5RaceProxy raceProxy) {
        SortObject obj;
        HashMap<Long, Integer> rankMap = new HashMap<Long, Integer>();
        LinkedList<SortObject> list = new LinkedList<SortObject>();
        int index = 0;
        for (PvP5RaceRole raceRole : raceProxy.getXRace().getAllrolescampa()) {
            obj = new SortObject(raceRole, 0, ++index);
            list.add(obj);
        }
        index = 0;
        for (PvP5RaceRole raceRole : raceProxy.getXRace().getAllrolescampb()) {
            obj = new SortObject(raceRole, 1, ++index);
            list.add(obj);
        }
        list.sort(new Comparator<SortObject>(){

            @Override
            public int compare(SortObject o1, SortObject o2) {
                int v = o2.obj.getScore() - o1.obj.getScore();
                if (v == 0) {
                    v = o1.index - o2.index;
                }
                if (v == 0) {
                    v = o1.camp - o2.camp;
                }
                if (v == 0) {
                    v = o1.obj.getRoleid() - o2.obj.getRoleid() > 0L ? 1 : -1;
                }
                return v;
            }
        });
        for (int i = 0; i < list.size(); ++i) {
            rankMap.put(((SortObject)list.get((int)i)).obj.getRoleid(), i + 1);
        }
        return rankMap;
    }

    public static List<PvP5RaceRole> getCurrentRankListAndSort(PvP5RaceProxy raceProxy, int recordMax) {
        LinkedList<PvP5RaceRole> tempRoleList = new LinkedList<PvP5RaceRole>();
        List roleListA = raceProxy.getXRace().getAllrolescampa();
        List roleListB = raceProxy.getXRace().getAllrolescampb();
        int max = Math.max(roleListA.size(), roleListB.size());
        max = Math.min(recordMax, max);
        for (int i = 0; i < max; ++i) {
            if (i < roleListA.size()) {
                tempRoleList.add((PvP5RaceRole)roleListA.get(i));
            }
            if (i >= roleListB.size()) continue;
            tempRoleList.add((PvP5RaceRole)roleListB.get(i));
        }
        Map<Long, Integer> currentRankMap = PvP5RankVisitor.getCurrentRankMap(raceProxy);
        tempRoleList.sort((Comparator<PvP5RaceRole>)new IPvPVisitor.Util.ComparatorRank<PvP5RaceRole>(currentRankMap){

            public int compare(PvP5RaceRole o1, PvP5RaceRole o2) {
                int v = o2.getScore() - o1.getScore();
                if (v == 0) {
                    v = this.compareRank(o1.getRoleid(), o2.getRoleid());
                }
                if (v == 0) {
                    v = o1.getRoleid() - o2.getRoleid() > 0L ? 1 : -1;
                }
                return v;
            }
        });
        return tempRoleList;
    }

    public static void sort(List<PvP5ScoreRecord> records, Map<Long, Integer> currentRankMap) {
        LinkedList<PvP5ScoreRecord> copyRankList = new LinkedList<PvP5ScoreRecord>();
        for (PvP5ScoreRecord record : records) {
            copyRankList.add(record);
        }
        records.clear();
        copyRankList.sort((Comparator<PvP5ScoreRecord>)new IPvPVisitor.Util.ComparatorRank<PvP5ScoreRecord>(currentRankMap){

            public int compare(PvP5ScoreRecord o1, PvP5ScoreRecord o2) {
                int v = o2.getScore() - o1.getScore();
                if (v == 0) {
                    v = this.compareRank(o1.getRoleid(), o2.getRoleid());
                }
                if (v == 0) {
                    v = o1.getRoleid() - o2.getRoleid() > 0L ? 1 : -1;
                }
                return v;
            }
        });
        records.addAll(copyRankList);
    }

    public static void resize(List<PvP5ScoreRecord> records, int recordMax) {
        while (records.size() > recordMax) {
            records.remove(records.size() - 1);
        }
    }

    public static void updateSchool(List<PvP5ScoreRecord> records, int recordShowMax) {
        int recordSize = records.size();
        for (int i = 0; i < recordSize && i < recordShowMax; ++i) {
            PvP5ScoreRecord record = records.get(i);
            if (record.getSchool() != 0) continue;
            int school = Properties.selectSchool((Long)record.getRoleid());
            record.setSchool(school);
        }
    }

    public static int getLastRankRecordMax(int rankType) {
        int recordMax = RankListManager.getInstance().getPersonNumMaxByType(rankType);
        recordMax = Math.max(recordMax, 0);
        return recordMax;
    }

    public static int getHistoryRankRecordMax(int rankType) {
        int recordShowMax = 100;
        int recordMax = recordShowMax * 60;
        recordMax = Math.max(recordMax, 0);
        return recordMax;
    }

    public static int getHistoryRankRecordShowMax(int rankType) {
        int recordShowMax = RankListManager.getInstance().getPersonNumMaxByType(rankType);
        recordShowMax = Math.max(recordShowMax, 0);
        return recordShowMax;
    }

    public static int getLastRankType(int grade) {
        switch (grade) {
            case 1: {
                return 81;
            }
            case 2: {
                return 82;
            }
            case 3: {
                return 83;
            }
            case 4: {
                return 87;
            }
            case 5: {
                return 88;
            }
            case 6: {
                return 89;
            }
        }
        return -1;
    }

    public static int getLastRankGrade(int rankType) {
        switch (rankType) {
            case 81: {
                return 1;
            }
            case 82: {
                return 2;
            }
            case 83: {
                return 3;
            }
            case 87: {
                return 4;
            }
            case 88: {
                return 5;
            }
            case 89: {
                return 6;
            }
        }
        return -1;
    }

    public static int getHistoryRankType(int grade) {
        switch (grade) {
            case 1: {
                return 84;
            }
            case 2: {
                return 85;
            }
            case 3: {
                return 86;
            }
            case 4: {
                return 90;
            }
            case 5: {
                return 91;
            }
            case 6: {
                return 92;
            }
        }
        return -1;
    }

    public static int getHistoryRankGrade(int rankType) {
        switch (rankType) {
            case 84: {
                return 1;
            }
            case 85: {
                return 2;
            }
            case 86: {
                return 3;
            }
            case 90: {
                return 4;
            }
            case 91: {
                return 5;
            }
            case 92: {
                return 6;
            }
        }
        return -1;
    }

    public static class SortObject {
        public PvP5RaceRole obj;
        public byte camp;
        public int index;

        public SortObject(PvP5RaceRole obj, byte camp, int index) {
            this.obj = obj;
            this.camp = camp;
            this.index = index;
        }
    }
}

